<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\training;


use app\common\model\training\TrainingTask;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * TrainingTask逻辑
 * Class TrainingTaskLogic
 * @package app\adminapi\logic
 */
class TrainingTaskLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/14 17:45
     */
    public static function add(array $params): bool
    {
        if($params['subclass']) $params['subclass'] = end($params['subclass']);
        Db::startTrans();
        try {
            TrainingTask::create([
                'task_name' => $params['task_name'],
                'training_course_id' => array_map('intval', $params['training_course_id']),
                'subclass' => $params['subclass']??0,
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/14 17:45
     */
    public static function edit(array $params): bool
    {
        if($params['subclass']) $params['subclass'] = end($params['subclass']);
        Db::startTrans();
        try {
            TrainingTask::where('id', $params['id'])->update([
                'task_name' => $params['task_name'],
                'training_course_id' => json_encode(array_map('intval', $params['training_course_id'])),
                'subclass' => $params['subclass']??0,
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/02/14 17:45
     */
    public static function delete(array $params): bool
    {
        return TrainingTask::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2025/02/14 17:45
     */
    public static function detail($params): array
    {
        return TrainingTask::findOrEmpty($params['id'])->toArray();
    }
}